//------------------------------------------------------------------
#property copyright "Copyright  2007, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"
//------------------------------------------------------------------
#property  indicator_separate_window
#property indicator_buffers 1
#property indicator_color1 Blue
#property indicator_level1 27
#property indicator_level2 26.5
#property indicator_levelcolor Blue
#property strict

extern int  EMAPeriod    = 9;  // EMA period
extern int  SecondPeriod = 9;  // Second EMA period
extern int  SumPeriod    = 25; // Sum period
//---- buffers
double MI[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
   SetIndexBuffer(0, MI);
   IndicatorShortName("Mass Index(" + (string)EMAPeriod + "," + (string)SecondPeriod + "," + (string)SumPeriod + ")");
   return(0);
}
int deinit() { return(0); }

//------------------------------------------------------------------
//
//------------------------------------------------------------------
int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);

   for(int i=limit; i>=0; i--)
   {
       double HL        = High[i] - Low[i];
       double HLaverage = iEma(HL,EMAPeriod,i,0);
       double EMA2      = HLaverage / iEma(HLaverage, SecondPeriod, i, 1);
              MI[i]     = iSma(EMA2,SumPeriod,i)*SumPeriod;
   }
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

#define _smaInstances 2
double workSma[][_smaInstances];
double iSma(double price, int period, int r, int instanceNo=0)
{
   if (ArrayRange(workSma,0)!= Bars) ArrayResize(workSma,Bars); instanceNo *= 2; r=Bars-r-1; int k;

   workSma[r][instanceNo+0] = price;
   workSma[r][instanceNo+1] = price; for(k=1; k<period && (r-k)>=0; k++) workSma[r][instanceNo+1] += workSma[r-k][instanceNo+0];  
   workSma[r][instanceNo+1] /= 1.0*k;
   return(workSma[r][instanceNo+1]);
}

//
//
//
//
//

#define _emaInstances 2
double workEma[][_emaInstances];
double iEma(double price, double period, int r, int instanceNo=0)
{
   if (ArrayRange(workEma,0)!= Bars) ArrayResize(workEma,Bars); r=Bars-r-1;

   workEma[r][instanceNo] = price;
   if (r>0 && period>1)
          workEma[r][instanceNo] = workEma[r-1][instanceNo]+(2.0/(1.0+period))*(price-workEma[r-1][instanceNo]);
   return(workEma[r][instanceNo]);
}